<template>
  <client-only>
    <v-datepicker
      v-model="inputValue"
      maximum-view="day"
      :disabled-dates="{
        to: disabledTo,
        from: disabledFrom,
        dates: filteredDisabledDateList,
      }"
      :highlighted="highlighted"
      :monday-first="true"
      :full-month-name="true"
      :class="['datepicker', variant]"
      :input-class="'input'"
      :calendar-class="'calendar'"
      :language="langs[$i18n.locale]"
      @input="onDateInput"
    />
  </client-only>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  ref,
} from "@nuxtjs/composition-api";
import vDatepicker from "vuejs-datepicker";
import { en, nl } from "vuejs-datepicker/dist/locale";
import useFiltering from "~/composables/filtering";

export default defineComponent({
  components: {
    vDatepicker,
  },

  props: {
    defaultValue: {
      type: Date,
      default: new Date(),
    },
    highlighted: {
      type: Object,
      default: null,
    },
    disabledTo: {
      type: Date,
      default: null,
    },
    disabledFrom: {
      type: Date,
      default: null,
    },
    disabledDateList: {
      type: Array,
      default: () => [],
    },
    variant: {
      type: String,
      default: "outlined",
    },
  },

  setup (props, ctx) {
    const { filter } = useFiltering();

    const langs = {
      en,
      nl,
    };

    const inputValue = ref(props.defaultValue);

    const filteredDisabledDateList = computed(() => {
      return props.disabledDateList.reduce((acc: Date[], cur: Date) => {
        if (props.highlighted.dates.filter(highlightedDate => highlightedDate.toDateString() === cur.toDateString()).length <= 0) {
          acc = [...acc, cur];
        }

        return acc;
      }, []);
    });

    /**
     * Emit value input uptream.
     */
    function onDateInput ($event) {
      filter(String(inputValue.value), "daterange");
      ctx.emit("date-input", { $event, value: inputValue.value });
    }

    return {
      langs,
      inputValue,
      filteredDisabledDateList,
      onDateInput,
    };
  },
});
</script>

<style lang="postcss">
/* Overriding vue-datepicker styling */
.datepicker {
  --calendar-input-height: 44px;

  height: var(--calendar-input-height);

  @apply flex w-full select-none;

  & > div:first-of-type {
    padding-top: 2px;

    @apply relative inline-flex align-middle w-full;

    .input {
      padding-inline: 10px;

      @apply w-full h-full text-base bg-transparent z-10;

      &:hover,
      &:focus {
        @apply outline-none cursor-pointer;
      }
    }

    &::after {
      --calendar-icon-size: 20px;

      top: calc((var(--calendar-input-height) - var(--calendar-icon-size)) / 2);
      right: calc((var(--calendar-input-height) - var(--calendar-icon-size)) / 2);
      background-image: url("data:image/svg+xml,%3Csvg width='32' height='32' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M10 0v4h12V0h4v4h6v28H0V4h6V0h4zm18 12H4v16h24V12zm-16 9v4H8v-4h4zm6 0v4h-4v-4h4zm-6-6v4H8v-4h4zm6 0v4h-4v-4h4zm6 0v4h-4v-4h4z' fill='%23000' fill-rule='evenodd'/%3E%3C/svg%3E");
      background-position: center center;
      background-repeat: no-repeat;
      background-size: contain;
      width: var(--calendar-icon-size);
      height: var(--calendar-icon-size);
      content: "";

      @apply absolute flex justify-center items-center z-0;
    }

    &::placeholder {
      @apply opacity-100 text-gray-400;
    }

    &:disabled {
      @apply border-gray-200 bg-gray-200 text-gray-400;
    }
  }

  .calendar {
    top: var(--calendar-input-height);
    width: 240px;

    @apply border-1 border-black;

    .prev,
    .next {
      @apply relative bg-white;

      &::after {
        top: 0;
        left: 3px;
        transform: scale(0.8);
        border: 0;
        background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 13 20' width='13' height='20'%3E%3Cpath fill='currentColor' fill-rule='evenodd' d='M2.098 20L.286 18.181 8.461 10 .286 1.819 2.098 0l10 10z'/%3E%3C/svg%3E");
        background-position: center center;
        background-repeat: no-repeat;
        width: 100%;
        height: 100%;
        content: "";

        @apply absolute flex border-0 justify-center items-center;
      }

      &.disabled::after {
        opacity: 0.25;
        border: 0;
      }
    }

    .prev::after {
      transform: scale(0.8) rotate(180deg);
    }

    .next::after {
      right: 0;
      left: auto;
    }

    .day__month_btn {
      @apply text-xl text-black font-bold;
    }

    .cell,
    .cell-disabled {
      @apply bg-white p-0 h-8 leading-8 text-gray-600 font-normal;
    }

    .disabled {
      /* text-decoration: line-through; */
      @apply cursor-not-allowed;
    }

    .cell.today {
      @apply border-1 border-gray-900;
    }

    .cell.highlighted {
      @apply bg-white text-black font-bold;
    }

    .cell.selected,
    .cell.highlighted.selected {
      @apply bg-red-800 text-white font-bold;
    }

    .cell:not(.blank):not(.disabled).day,
    .cell:not(.blank):not(.disabled).month,
    .cell:not(.blank):not(.disabled).year {
      &:hover,
      &:focus,
      &:active {
        @apply border-transparent text-red-800;

        &.today {
          @apply border-gray-900;
        }
      }

    }
  }

  &.outlined {
    & > div:first-of-type {
      @apply border-1 border-black py-0 w-full h-full bg-white leading-none;
    }
  }
}
</style>
